/**
* 
* @module Kiwi
* @submodule Input
* 
*/

module Kiwi.Input {

	/**
	* A Static class which has a property associated with all all of the character codes on a typical keyboard. While you don't need this class for your game to work, it is quite handy to use as it can speed up the development process.
	*
	* @class Keycodes
	* @namespace Kiwi.Input
	* @static
	*/
	export class Keycodes {

		/**
		* The type of object that this is.
		* @method objType
		* @return {string} "Keycodes"
		* @public
		*/
		public objType() {
			return "Keycodes";
		}

		/**
		* A Static property that holds the keycode for the character A
		* @property A
		* @static
		* @final
		* @public
		*/
		public static A: number = "A".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character B
		* @property B
		* @static
		* @final
		* @public
		*/
		public static B: number = "B".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character C
		* @property C
		* @static
		* @final
		* @public
		*/
		public static C: number = "C".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character D
		* @property D
		* @static
		* @final
		* @public
		*/
		public static D: number = "D".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character E
		* @property E
		* @static
		* @final
		* @public
		*/
		public static E: number = "E".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character F
		* @property F
		* @static
		* @final
		* @public
		*/
		public static F: number = "F".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character G
		* @property G
		* @static
		* @final
		* @public
		*/
		public static G: number = "G".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character H
		* @property H
		* @static
		* @final
		* @public
		*/
		public static H: number = "H".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character I
		* @property I
		* @static
		* @final
		* @public
		*/
		public static I: number = "I".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character J
		* @property J
		* @static
		* @final
		* @public
		*/
		public static J: number = "J".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character K
		* @property K
		* @static
		* @final
		* @public
		*/
		public static K: number = "K".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character L
		* @property L
		* @static
		* @final
		* @public
		*/
		public static L: number = "L".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character M
		* @property M
		* @static
		* @final
		* @public
		*/
		public static M: number = "M".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character N
		* @property N
		* @static
		* @final
		* @public
		*/
		public static N: number = "N".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character O
		* @property O
		* @static
		* @final
		* @public
		*/
		public static O: number = "O".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character P
		* @property P
		* @static
		* @final
		* @public
		*/
		public static P: number = "P".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character Q
		* @property Q
		* @static
		* @final
		* @public
		*/
		public static Q: number = "Q".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character R
		* @property R
		* @static
		* @final
		* @public
		*/
		public static R: number = "R".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character S
		* @property S
		* @static
		* @final
		* @public
		*/
		public static S: number = "S".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character T
		* @property T
		* @static
		* @final
		* @public
		*/
		public static T: number = "T".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character U
		* @property U
		* @static
		* @final
		* @public
		*/
		public static U: number = "U".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character V
		* @property V
		* @static
		* @final
		* @public
		*/
		public static V: number = "V".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character W
		* @property W
		* @static
		* @final
		* @public
		*/
		public static W: number = "W".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character X
		* @property X
		* @static
		* @final
		* @public
		*/
		public static X: number = "X".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character Y
		* @property Y
		* @static
		* @final
		* @public
		*/
		public static Y: number = "Y".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character Z
		* @property Z
		* @static
		* @final
		* @public
		*/
		public static Z:number = "Z".charCodeAt(0);


		/**
		* A Static property that holds the keycode for the character 0
		* @property ZERO
		* @static
		* @final
		* @public
		*/
		public static ZERO: number = "0".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 1
		* @property ONE
		* @static
		* @final
		* @public
		*/
		public static ONE: number = "1".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 2
		* @property TWO
		* @static
		* @final
		* @public
		*/
		public static TWO: number = "2".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 3
		* @property THREE
		* @static
		* @final
		* @public
		*/
		public static THREE: number = "3".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 4
		* @property FOUR
		* @static
		* @final
		* @public
		*/
		public static FOUR: number = "4".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 5
		* @property FIVE
		* @static
		* @final
		* @public
		*/
		public static FIVE: number = "5".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 6
		* @property SIX
		* @static
		* @final
		* @public
		*/
		public static SIX: number = "6".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 7
		* @property SEVEN
		* @static
		* @final
		* @public
		*/
		public static SEVEN: number = "7".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 8
		* @property EIGHT
		* @static
		* @final
		* @public
		*/
		public static EIGHT: number = "8".charCodeAt(0);

		/**
		* A Static property that holds the keycode for the character 9
		* @property NINE
		* @static
		* @final
		* @public
		*/
		public static NINE:number = "9".charCodeAt(0);
		

		/**
		* A Static property that holds the keycode for the character number pad 0
		* @property NUMPAD_0
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_0: number = 96;

		/**
		* A Static property that holds the keycode for the character number pad 1
		* @property NUMPAD_1
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_1: number = 97;

		/**
		* A Static property that holds the keycode for the character number pad 2
		* @property NUMPAD_2
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_2: number = 98;

		/**
		* A Static property that holds the keycode for the character number pad 3
		* @property NUMPAD_3
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_3: number = 99;

		/**
		* A Static property that holds the keycode for the character number pad 4
		* @property NUMPAD_4
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_4: number = 100;

		/**
		* A Static property that holds the keycode for the character number pad 5
		* @property NUMPAD_5
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_5: number = 101;

		/**
		* A Static property that holds the keycode for the character number pad 6
		* @property NUMPAD_6
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_6: number = 102;

		/**
		* A Static property that holds the keycode for the character number pad 7
		* @property NUMPAD_7
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_7: number = 103;

		/**
		* A Static property that holds the keycode for the character number pad 8
		* @property NUMPAD_8
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_8: number = 104;

		/**
		* A Static property that holds the keycode for the character number pad 9
		* @property NUMPAD_9
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_9: number = 105;

		/**
		* A Static property that holds the keycode for the character number pad *
		* @property NUMPAD_MULTIPLY
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_MULTIPLY: number = 106;

		/**
		* A Static property that holds the keycode for the character number pad +
		* @property NUMPAD_ADD
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_ADD: number = 107;

		/**
		* A Static property that holds the keycode for the character on the number pad enter
		* @property NUMPAD_ENTER
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_ENTER: number = 108;

		/**
		* A Static property that holds the keycode for the character number pad -
		* @property NUMPAD_SUBTRACT
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_SUBTRACT: number = 109;

		/**
		* A Static property that holds the keycode for the character number pad .
		* @property NUMPAD_DECIMAL
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_DECIMAL: number = 110;

		/**
		* A Static property that holds the keycode for the character /
		* @property NUMPAD_DIVIDE
		* @static
		* @final
		* @public
		*/
		public static NUMPAD_DIVIDE:number = 111;
		

		/**
		* A Static property that holds the keycode for the character F1
		* @property F1
		* @static
		* @final
		* @public
		*/
		public static F1: number = 112;

		/**
		* A Static property that holds the keycode for the character F2
		* @property F2
		* @static
		* @final
		* @public
		*/
		public static F2: number = 113;

		/**
		* A Static property that holds the keycode for the character F3
		* @property F3
		* @static
		* @final
		* @public
		*/
		public static F3: number = 114;

		/**
		* A Static property that holds the keycode for the character F4
		* @property F4
		* @static
		* @final
		* @public
		*/
		public static F4: number = 115;

		/**
		* A Static property that holds the keycode for the character F5
		* @property F5
		* @static
		* @final
		* @public
		*/
		public static F5: number = 116;

		/**
		* A Static property that holds the keycode for the character F6
		* @property F6
		* @static
		* @final
		* @public
		*/
		public static F6: number = 117;

		/**
		* A Static property that holds the keycode for the character F7
		* @property F7
		* @static
		* @final
		* @public
		*/
		public static F7: number = 118;

		/**
		* A Static property that holds the keycode for the character F8
		* @property F8
		* @static
		* @final
		* @public
		*/
		public static F8: number = 119;

		/**
		* A Static property that holds the keycode for the character F9
		* @property F9
		* @static
		* @final
		* @public
		*/
		public static F9: number = 120;

		/**
		* A Static property that holds the keycode for the character F10
		* @property F10
		* @static
		* @final
		* @public
		*/
		public static F10: number = 121;

		/**
		* A Static property that holds the keycode for the character F11
		* @property F11
		* @static
		* @final
		* @public
		*/
		public static F11: number = 122;

		/**
		* A Static property that holds the keycode for the character F12
		* @property F12
		* @static
		* @final
		* @public
		*/
		public static F12: number = 123;

		/**
		* A Static property that holds the keycode for the character F13
		* @property F13
		* @static
		* @final
		* @public
		*/
		public static F13: number = 124;

		/**
		* A Static property that holds the keycode for the character F14
		* @property F14
		* @static
		* @final
		* @public
		*/
		public static F14: number = 125;

		/**
		* A Static property that holds the keycode for the character F15
		* @property F15
		* @static
		* @final
		* @public
		*/
		public static F15:number = 126;

		/**
		* A Static property that holds the keycode for the character COLON
		* @property COLON
		* @static
		* @final
		* @public
		*/
		public static COLON: number = 186;

		/**
		* A Static property that holds the keycode for the character =
		* @property EQUALS
		* @static
		* @final
		* @public
		*/
		public static EQUALS: number = 187;

		/**
		* A Static property that holds the keycode for the character UNDERSCORE
		* @property UNDERSCORE
		* @static
		* @final
		* @public
		*/
		public static UNDERSCORE: number = 189;

		/**
		* A Static property that holds the keycode for the character QUESTION_MARK
		* @property QUESTION_MARK
		* @static
		* @final
		* @public
		*/
		public static QUESTION_MARK: number = 191;

		/**
		* A Static property that holds the keycode for the character TILDE
		* @property TILDE
		* @static
		* @final
		* @public
		*/
		public static TILDE: number = 192;

		/**
		* A Static property that holds the keycode for the character OPEN_BRAKET
		* @property OPEN_BRACKET
		* @static
		* @final
		* @public
		*/
		public static OPEN_BRACKET: number = 219;

		/**
		* A Static property that holds the keycode for the character BACKWARD_SLASH
		* @property BACKWARD_SLASH
		* @static
		* @final
		* @public
		*/
		public static BACKWARD_SLASH: number = 220;

		/**
		* A Static property that holds the keycode for the character CLOSED_BRACKET
		* @property CLOSED_BRACKET
		* @static
		* @final
		* @public
		*/
		public static CLOSED_BRACKET: number = 221;

		/**
		* A Static property that holds the keycode for the character QUOTES
		* @property QUOTES
		* @static
		* @final
		* @public
		*/
		public static QUOTES:number = 222;
		

		/**
		* A Static property that holds the keycode for the character BACKSPACE
		* @property BACKSPACE
		* @static
		* @final
		* @public
		*/
		public static BACKSPACE: number = 8;

		/**
		* A Static property that holds the keycode for the character TAB
		* @property TAB
		* @static
		* @final
		* @public
		*/
		public static TAB: number = 9;

		/**
		* A Static property that holds the keycode for the character CLEAR
		* @property CLEAR
		* @static
		* @final
		* @public
		*/
		public static CLEAR: number = 12;

		/**
		* A Static property that holds the keycode for the character ENTER
		* @property ENTER
		* @static
		* @final
		* @public
		*/
		public static ENTER: number = 13;

		/**
		* A Static property that holds the keycode for the character SHIFT
		* @property SHIFT
		* @static
		* @final
		* @public
		*/
		public static SHIFT: number = 16;

		/**
		* A Static property that holds the keycode for the character CONTROL
		* @property CONTROL
		* @static
		* @final
		* @public
		*/
		public static CONTROL: number = 17;

		/**
		* A Static property that holds the keycode for the character ALT
		* @property ALT
		* @static
		* @final
		* @public
		*/
		public static ALT: number = 18;

		/**
		* A Static property that holds the keycode for the character CAPS_LOCK
		* @property CAPS_LOCK
		* @static
		* @final
		* @public
		*/
		public static CAPS_LOCK: number = 20;

		/**
		* A Static property that holds the keycode for the character ESC
		* @property ESC
		* @static
		* @final
		* @public
		*/
		public static ESC: number = 27;

		/**
		* A Static property that holds the keycode for the character SPACEBAR
		* @property SPACEBAR
		* @static
		* @final
		* @public
		*/
		public static SPACEBAR: number = 32;

		/**
		* A Static property that holds the keycode for the character PAGE_UP
		* @property PAGE_UP
		* @static
		* @final
		* @public
		*/
		public static PAGE_UP: number = 33;

		/**
		* A Static property that holds the keycode for the character PAGE_DOWN
		* @property PAGE_DOWN
		* @static
		* @final
		* @public
		*/
		public static PAGE_DOWN: number = 34;

		/**
		* A Static property that holds the keycode for the character END
		* @property END
		* @static
		* @final
		* @public
		*/
		public static END: number = 35;

		/**
		* A Static property that holds the keycode for the character HOME
		* @property HOME
		* @static
		* @final
		* @public
		*/
		public static HOME: number = 36;

		/**
		* A Static property that holds the keycode for the character LEFT
		* @property LEFT
		* @static
		* @final
		* @public
		*/
		public static LEFT: number = 37;

		/**
		* A Static property that holds the keycode for the character UP
		* @property UP
		* @static
		* @final
		* @public
		*/
		public static UP: number = 38;

		/**
		* A Static property that holds the keycode for the character RIGHT
		* @property RIGHT
		* @static
		* @final
		* @public
		*/
		public static RIGHT: number = 39;

		/**
		* A Static property that holds the keycode for the character DOWN
		* @property DOWN
		* @static
		* @final
		* @public
		*/
		public static DOWN: number = 40;

		/**
		* A Static property that holds the keycode for the character INSERT
		* @property INSERT
		* @static
		* @final
		* @public
		*/
		public static INSERT: number = 45;

		/**
		* A Static property that holds the keycode for the character DELETE
		* @property DELETE
		* @static
		* @final
		* @public
		*/
		public static DELETE: number = 46;

		/**
		* A Static property that holds the keycode for the character HELP
		* @property HELP
		* @static
		* @final
		* @public
		*/
		public static HELP: number = 47;

		/**
		* A Static property that holds the keycode for the character NUM_LOCK
		* @property NUM_LOCK
		* @static
		* @final
		* @public
		*/
		public static NUM_LOCK: number = 144;

	}

}
